// Pixels.h : CPixels ̐錾

#pragma once
#include "resource.h"       // C V{
#include "atlimage.h"


// IPixels
[
	object,
	uuid("99310283-EDE1-4896-8E9D-94F0210DFF09"),
	dual,	helpstring("IPixels C^[tFCX"),
	pointer_default(unique)
]
__interface IPixels : IDispatch
{
	[id(1), helpstring("\bhload")] HRESULT load([in] BSTR bstrFileName);
	[id(2), helpstring("\bhsave")] HRESULT save([in] BSTR bstrFileName);
	[id(3), helpstring("\bhresize")] HRESULT resize(LONG iWidth, LONG iHeight);
	[id(4), helpstring("\bhmonochrome")] HRESULT monochrome(void);
	[propget, id(5), helpstring("vpeBWidth")] HRESULT Width([out, retval] LONG* pVal);
	[propget, id(6), helpstring("vpeBHeight")] HRESULT Height([out, retval] LONG* pVal);
};



// CPixels

[
	coclass,
	threading("apartment"),
	support_error_info("IPixels"),
	vi_progid("C3Image.Pixels"),
	progid("C3Image.Pixels.1"),
	version(1.0),
	uuid("8D0B072D-2829-4E6D-B455-3E0288E78DDA"),
	helpstring("Pixels Class")
]
class ATL_NO_VTABLE CPixels : 
	public IPixels
{
public:
	CPixels()
	{
	}


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:

	STDMETHOD(load)(BSTR bstrFileName);
private:
	CImage m_imgImage;
public:
	STDMETHOD(save)(BSTR bstrFileName);
	STDMETHOD(resize)(LONG iWidth, LONG iHeight);
	STDMETHOD(monochrome)(void);
	STDMETHOD(get_Width)(LONG* pVal);
	STDMETHOD(get_Height)(LONG* pVal);
};

